Index: issm/trunk/src/m/plot/radarpower.m
===================================================================
--- issm/trunk/src/m/plot/radarpower.m	(revision 13405)
+++ issm/trunk/src/m/plot/radarpower.m	(revision 13975)
@@ -32,12 +32,12 @@
 if ~exist(options,'overlay_image'),
 	if strcmpi(md.mesh.hemisphere,'n'),
-		%if ~exist([jplsvn() '/projects/ModelData/MOG/mog150_greenland_map.jpg']),
-		%	error(['radarpower error message: file ' jplsvn() '/projects/ModelData/MOG/mog150_greenland_map.jpg not found.']);
+		%if ~exist(['/u/astrid-r1b/ModelData/MOG/mog150_greenland_map.jpg']),
+		%	error(['radarpower error message: file ' '/u/astrid-r1b/ModelData/MOG/mog150_greenland_map.jpg not found.']);
 		%end
 		%name = 'mog150_greenland_map';
 		%name = 'mog100_hp1_v10';
 		%%name = 'mog500_hp1_v10';
-		%jpgim=[jplsvn() '/projects/ModelData/MOG/' name '.jpg'];
-		%geom=load([jplsvn() '/projects/ModelData/MOG/' name '.jpgw'],'ascii');
+		%jpgim=['/u/astrid-r1b/ModelData/MOG/' name '.jpg'];
+		%geom=load(['/u/astrid-r1b/ModelData/MOG/' name '.jpgw'],'ascii');
 		%%jpgim='/u/astrid-r1b/morlighe/issmjpl/projects/MorlighemGRL2012/Data/Mosaic_amp_asar2010.jpg';
 		%%geom=load('/u/astrid-r1b/morlighe/issmjpl/projects/MorlighemGRL2012/Data/Mosaic_amp_asar2010.jpgw');
@@ -65,13 +65,13 @@
 		%md.radaroverlay.y=(ymin:(ymax-ymin)/(size(md.radaroverlay.pwr,1)-1):ymax);
 		if highres,
-			if ~exist([jplsvn() '/projects/ModelData/MOG/mog100g_r2_hp1.tif']),
-				error(['radarpower error message: file ' jplsvn() '/projects/ModelData/MOG/mog100g_r2_hp1.tif not found.']);
+			if ~exist(['/u/astrid-r1b/ModelData/MOG/mog100_r2_hp1.tif']),
+				error(['radarpower error message: file ' '/u/astrid-r1b/ModelData/MOG/mog100_r2_hp1.tif not found.']);
 			end
-			geotiff_name=[jplsvn() '/projects/ModelData/MOG/mog100_r2_hp1.tif'];
+			geotiff_name=['/u/astrid-r1b/ModelData/MOG/mog100_r2_hp1.tif'];
 		else
-			if ~exist([jplsvn() '/projects/ModelData/MOG/mog500g_r2_hp1.tif']),
-				error(['radarpower error message: file ' jplsvn() '/projects/ModelData/MOG/mog500g_r2_hp1.tif not found.']);
+			if ~exist(['/u/astrid-r1b/ModelData/MOG/mog500_r2_hp1.tif']),
+				error(['radarpower error message: file ' '/u/astrid-r1b/ModelData/MOG/mog500_r2_hp1.tif not found.']);
 			end
-			geotiff_name=[jplsvn() '/projects/ModelData/MOG/mog500_r2_hp1.tif'];
+			geotiff_name=['/u/astrid-r1b/ModelData/MOG/mog500_r2_hp1.tif'];
 		end
 
@@ -90,16 +90,15 @@
 		system('rm -rf ./temp.tif');
 
-
 	elseif strcmpi(md.mesh.hemisphere,'s'),
 		if highres,
-			if ~exist([jplsvn() '/projects/ModelData/MosaicTiffRsat/amm125m_v2_200m.tif']),
-				error(['radarpower error message: file ' jplsvn() '/projects/ModelData/MosaicTiffRsat/amm125m_v2_200m.tif not found.']);
+			if ~exist(['/u/astrid-r1b/ModelData/MosaicTiffRsat/amm125m_v2_200m.tif']),
+				error(['radarpower error message: file ' '/u/astrid-r1b/ModelData/MosaicTiffRsat/amm125m_v2_200m.tif not found.']);
 			end
-			geotiff_name=[jplsvn() '/projects/ModelData/MosaicTiffRsat/amm125m_v2_200m.tif'];
+			geotiff_name=['/u/astrid-r1b/ModelData/MosaicTiffRsat/amm125m_v2_200m.tif'];
 		else
-			if ~exist([jplsvn() '/projects/ModelData/MosaicTiffRsat/amm125m_v2_1km.tif']),
-				error(['radarpower error message: file ' jplsvn() '/projects/ModelData/MosaicTiffRsat/amm125m_v2_1km.tif not found.']);
+			if ~exist(['/u/astrid-r1b/ModelData/MosaicTiffRsat/amm125m_v2_1km.tif']),
+				error(['radarpower error message: file ' '/u/astrid-r1b/ModelData/MosaicTiffRsat/amm125m_v2_1km.tif not found.']);
 			end
-			geotiff_name=[jplsvn() '/projects/ModelData/MosaicTiffRsat/amm125m_v2_1km.tif'];
+			geotiff_name=['/u/astrid-r1b/ModelData/MosaicTiffRsat/amm125m_v2_1km.tif'];
 		end
 
Index: issm/trunk/src/m/plot/subplotmodel.m
===================================================================
--- issm/trunk/src/m/plot/subplotmodel.m	(revision 13405)
+++ issm/trunk/src/m/plot/subplotmodel.m	(revision 13975)
@@ -1,3 +1,3 @@
-function ha=subplotmodel(nlines,ncols,num,options);
+function ha=subplotmodel(nlines,ncols,num,options)
 %SUBPLOTMODEL -  tight subplot that includes margins
 %
Index: issm/trunk/src/m/qmu/MassFluxProcessProfile.m
===================================================================
--- issm/trunk/src/m/qmu/MassFluxProcessProfile.m	(revision 13405)
+++ issm/trunk/src/m/qmu/MassFluxProcessProfile.m	(revision 13975)
@@ -1,3 +1,3 @@
-function segments=MassFluxProcessProfile(md,directory,profilename);
+function segments=MassFluxProcessProfile(md,directory,profilename)
 %MASSFLUXPROCESSPROFILE: process an argus domain outlien profile into a list of segments.
 %
@@ -7,5 +7,4 @@
 % See also: PROCESS_QMU_RESPONSE_DATA, PREQMU
 
-
 %first read the profile points.
 profile=expread([directory '/' profilename]);
Index: issm/trunk/src/m/qmu/qmumarshall.m
===================================================================
--- issm/trunk/src/m/qmu/qmumarshall.m	(revision 13405)
+++ issm/trunk/src/m/qmu/qmumarshall.m	(revision 13975)
@@ -47,5 +47,5 @@
 	end
 end
-			
+
 if qmu_segments,
 	WriteData(fid,md.qmu.mass_flux_num_profiles,'Integer','qmu_mass_flux_num_profiles');
@@ -57,5 +57,4 @@
 	WriteData(fid,md.qmu.mass_flux_num_profiles,'Integer','qmu_mass_flux_num_profiles');
 end
-
 
 %write part and npart to disk
@@ -71,5 +70,5 @@
 end
 
-function qmumarshallusage();
+function qmumarshallusage()
 disp(' ');
 disp('function qmumarshall(md.qmu.variables,responses)');
Index: issm/trunk/src/m/regional/BasinConstrain.m
===================================================================
--- issm/trunk/src/m/regional/BasinConstrain.m	(revision 13405)
+++ issm/trunk/src/m/regional/BasinConstrain.m	(revision 13975)
@@ -1,3 +1,3 @@
-function md=BasinConstrain(md,domain);
+function md=BasinConstrain(md,domain)
 %BASINCONSTRAIN - constrain basin
 %
Index: issm/trunk/src/m/regional/BasinConstrainShelf.m
===================================================================
--- issm/trunk/src/m/regional/BasinConstrainShelf.m	(revision 13405)
+++ issm/trunk/src/m/regional/BasinConstrainShelf.m	(revision 13975)
@@ -1,3 +1,3 @@
-function md=BasinConstrainShelf(md,domain);
+function md=BasinConstrainShelf(md,domain)
 %BASINCONSTRAIN - constrain basin
 %
Index: issm/trunk/src/m/regional/regionaltransient2d.m
===================================================================
--- issm/trunk/src/m/regional/regionaltransient2d.m	(revision 13405)
+++ issm/trunk/src/m/regional/regionaltransient2d.m	(revision 13975)
@@ -31,5 +31,5 @@
 
 %take every fields from model
-mde=modelextract(md1,area);
+mde=md1.extract(area);
 mde.private.bamg=[];
 mde.mesh.extractedvertices=nan;
@@ -131,5 +131,5 @@
 	%Diagnostic.  Don't spc the icefront vertices.
 	if ~isnan(md2.diagnostic.icefront)
-		md1s=modelextract(md1,area);
+		md1s=md1.extract(area);
 		%md2.diagnostic.icefront=[md2.mesh.segments 2];
 		e2=md2.mesh.segments(:,end);
@@ -156,3 +156,2 @@
 		md2.results=[];
 	end
-
Index: issm/trunk/src/m/solve/MatlabProcessPatch.m
===================================================================
--- issm/trunk/src/m/solve/MatlabProcessPatch.m	(revision 13405)
+++ issm/trunk/src/m/solve/MatlabProcessPatch.m	(revision 13975)
@@ -1,3 +1,3 @@
-function structure=MatlabProcessPatch(structure);
+function structure=MatlabProcessPatch(structure)
 %PROCESSPATCH - create a structure from a patch
 %
Index: issm/trunk/src/m/solve/MatlabProcessPatch.py
===================================================================
--- issm/trunk/src/m/solve/MatlabProcessPatch.py	(revision 13405)
+++ issm/trunk/src/m/solve/MatlabProcessPatch.py	(revision 13975)
@@ -8,8 +8,8 @@
 
 	#loop over steps
-	for structurei in structure.itervalues():
+	for structurei in structure:
 
 		#return if there is no field Patch
-		if 'Patch' not in structurei:
+		if not hasattr(structurei,'Patch'):
 			continue
 
Index: issm/trunk/src/m/solve/WriteData.m
===================================================================
--- issm/trunk/src/m/solve/WriteData.m	(revision 13405)
+++ issm/trunk/src/m/solve/WriteData.m	(revision 13975)
@@ -231,5 +231,5 @@
 
 	%Get Enum
-	enum=eval([string 'Enum();']); 
+	enum=StringToEnum(string); 
 end % }}}
 function code=FormatToCode(format) % {{{
Index: issm/trunk/src/m/solve/WriteData.py
===================================================================
--- issm/trunk/src/m/solve/WriteData.py	(revision 13405)
+++ issm/trunk/src/m/solve/WriteData.py	(revision 13975)
@@ -17,5 +17,5 @@
 	#process options
 	#  the import above the function level doesn't work?
-	from pairoptions import *
+	from pairoptions import pairoptions
 	options=pairoptions(*args)
 
@@ -101,6 +101,8 @@
 	elif strcmpi(format,'BooleanMat'):    # {{{
 
-		if isinstance(data,bool):
+		if   isinstance(data,bool):
 			data=numpy.array([data])
+		elif isinstance(data,(list,tuple)):
+			data=numpy.array(data).reshape(-1,1)
 		if len(data.shape) == 1:
 			if numpy.size(data):
@@ -132,6 +134,8 @@
 	elif strcmpi(format,'IntMat'):    # {{{
 
-		if isinstance(data,(int,long)):
+		if   isinstance(data,(int,long)):
 			data=numpy.array([data])
+		elif isinstance(data,(list,tuple)):
+			data=numpy.array(data).reshape(-1,1)
 		if len(data.shape) == 1:
 			if numpy.size(data):
@@ -163,6 +167,8 @@
 	elif strcmpi(format,'DoubleMat'):    # {{{
 
-		if isinstance(data,(bool,int,long,float)):
+		if   isinstance(data,(bool,int,long,float)):
 			data=numpy.array([data])
+		elif isinstance(data,(list,tuple)):
+			data=numpy.array(data).reshape(-1,1)
 		if len(data.shape) == 1:
 			if numpy.size(data):
@@ -197,6 +203,8 @@
 		recordlength=4+4    #number of records + code
 		for matrix in data:
-			if isinstance(matrix,(bool,int,long,float)):
+			if   isinstance(matrix,(bool,int,long,float)):
 				matrix=numpy.array([matrix])
+			elif isinstance(matrix,(list,tuple)):
+				matrix=numpy.array(matrix).reshape(-1,1)
 			if len(matrix.shape) == 1:
 				if numpy.size(matrix):
@@ -219,6 +227,8 @@
 		#write each matrix: 
 		for matrix in data:
-			if isinstance(matrix,(bool,int,long,float)):
+			if   isinstance(matrix,(bool,int,long,float)):
 				matrix=numpy.array([matrix])
+			elif isinstance(matrix,(list,tuple)):
+				matrix=numpy.array(matrix).reshape(-1,1)
 			if len(matrix.shape) == 1:
 				matrix=matrix.reshape(numpy.size(matrix),1)
@@ -276,5 +286,5 @@
 
 	#Get Enum
-	exec('enum='+string+'Enum()',globals())
+	enum=StringToEnum(string)[0]
 
 	return enum
Index: issm/trunk/src/m/solve/loadresultsfromdisk.py
===================================================================
--- issm/trunk/src/m/solve/loadresultsfromdisk.py	(revision 13405)
+++ issm/trunk/src/m/solve/loadresultsfromdisk.py	(revision 13975)
@@ -1,6 +1,7 @@
 import os
-from collections import OrderedDict
+from results import *
 from parseresultsfromdisk import *
 from EnumToString import EnumToString
+from MatlabFuncs import *
 
 def loadresultsfromdisk(md,filename):
@@ -23,31 +24,35 @@
 
 		#initialize md.results if not a structure yet
-		if not isinstance(md.results,dict):
-			md.results=OrderedDict()
+		if not isinstance(md.results,results):
+			md.results=results()
 
 		#load results onto model
-		structure=parseresultsfromdisk(filename,~md.settings.io_gather)
+		structure=parseresultsfromdisk(filename,not md.settings.io_gather)
 		if not len(structure):
 			raise RuntimeError("No result found in binary file '%s'. Check for solution crash." % filename)
-		md.results[structure[1]['SolutionType']]=structure;
+		setattr(md.results,structure[0].SolutionType,structure)
 
 		#recover solution_type from results
-		md.private.solution=structure[1]['SolutionType']
+		md.private.solution=structure[0].SolutionType
 
 		#read log files onto fields
 		if os.path.exists(md.miscellaneous.name+'.errlog'):
 			with open(md.miscellaneous.name+'.errlog','r') as f:
-				md.results[structure[1]['SolutionType']]['errlog']=[line[:-1] for line in f]
+				setattr(getattr(md.results,structure[0].SolutionType)[0],'errlog',[line[:-1] for line in f])
 		else:
-			md.results[structure[1]['SolutionType']]['errlog']=[]
+			setattr(getattr(md.results,structure[0].SolutionType)[0],'errlog',[])
 
 		if os.path.exists(md.miscellaneous.name+'.outlog'):
 			with open(md.miscellaneous.name+'.outlog','r') as f:
-				md.results[structure[1]['SolutionType']]['outlog']=[line[:-1] for line in f]
+				setattr(getattr(md.results,structure[0].SolutionType)[0],'outlog',[line[:-1] for line in f])
 		else:
-			md.results[structure[1]['SolutionType']]['outlog']=[]
+			setattr(getattr(md.results,structure[0].SolutionType)[0],'outlog',[])
 
-		if len(md.results[structure[1]['SolutionType']]['errlog']):
+		if len(getattr(md.results,structure[0].SolutionType)[0].errlog):
 			print ("loadresultsfromcluster info message: error during solution. Check your errlog and outlog model fields.")
+
+		#if only one solution, extract it from list for user friendliness
+		if len(structure) == 1 and not strcmp(structure[0].SolutionType,'TransientSolution'):
+			setattr(md.results,structure[0].SolutionType,structure[0])
 
 	#post processes qmu results if necessary
Index: issm/trunk/src/m/solve/marshall.m
===================================================================
--- issm/trunk/src/m/solve/marshall.m	(revision 13405)
+++ issm/trunk/src/m/solve/marshall.m	(revision 13975)
@@ -36,9 +36,5 @@
 	%Marshall current object
 	%disp(['marshalling ' field '...']);
-	if verLessThan('matlab', '7.6')
-		marshall(md.(field),fid);
-	else
-		md.(field).marshall(fid);
-	end
+	marshall(md.(field),fid);
 end
 
Index: issm/trunk/src/m/solve/parseresultsfromdisk.py
===================================================================
--- issm/trunk/src/m/solve/parseresultsfromdisk.py	(revision 13405)
+++ issm/trunk/src/m/solve/parseresultsfromdisk.py	(revision 13975)
@@ -2,4 +2,5 @@
 import numpy
 from collections import OrderedDict
+import results as resultsclass
 from MatlabFuncs import *
 from MatlabProcessPatch import *
@@ -37,22 +38,22 @@
 		raise IOError("loadresultsfromdisk error message: could not open '%s' for binary reading." % filename)
 
-	results=OrderedDict()
+	results=[]
 
 	#Read fields until the end of the file.
 	result=ReadData(fid)
 	while result:
+		if result['step'] > len(results):
+			for i in xrange(len(results),result['step']-1):
+				results.append(None)
+			results.append(resultsclass.results())
 		#Get time and step
-		if result['step'] not in results:
-			results[result['step']]=OrderedDict()
-			results[result['step']]['step']=result['step']
-			results[result['step']]['time']=result['time'] 
+		setattr(results[result['step']-1],'step',result['step'])
+		setattr(results[result['step']-1],'time',result['time']) 
 	
 		#Add result
-		if result['step'] in results and \
-		   result['fieldname'] in results[result['step']] and \
-		   not strcmp(result['fieldname'],'SolutionType'):
-			results[result['step']][result['fieldname']]=numpy.concatenate((results[result['step']][result['fieldname']],result['field']),axis=0)
-		else:
-			results[result['step']][result['fieldname']]=result['field']
+		if hasattr(results[result['step']-1],result['fieldname']) and not strcmp(result['fieldname'],'SolutionType'):
+			setattr(results[result['step']-1],result['fieldname'],numpy.vstack((getattr(results[result['step']-1],result['fieldname']),result['field'])))
+		else:
+			setattr(results[result['step']-1],result['fieldname'],result['field'])
 
 		#read next result
@@ -78,5 +79,5 @@
 		raise IOError("loadresultsfromdisk error message: could not open '%s' for binary reading." % filename)
 
-	results=OrderedDict()
+	results=[]
 
 	#if we have done split I/O, ie, we have results that are fragmented across patches, 
@@ -86,14 +87,16 @@
 
 		#Get time and step
-		if result['step'] not in results:
-			results[result['step']]=OrderedDict()
-			results[result['step']]['step']=result['step']
-			results[result['step']]['time']=result['time'] 
+		if result['step'] > len(results):
+			for i in xrange(len(results),result['step']-1):
+				results.append(None)
+			results.append(resultsclass.results())
+		setattr(results[result['step']-1],'step',result['step'])
+		setattr(results[result['step']-1],'time',result['time']) 
 
 		#Add result
 		if strcmpi(result['fieldname'],'Patch'):
-			results[result['step']][result['fieldname']]=[0,result['N']]
-		else:
-			results[result['step']][result['fieldname']]=float('NaN')
+			setattr(results[result['step']-1],result['fieldname'],[0,result['N']])
+		else:
+			setattr(results[result['step']-1],result['fieldname'],float('NaN'))
 
 		#read next result
@@ -107,6 +110,6 @@
 		#Add result
 		if strcmpi(result['fieldname'],'Patch'):
-			patchdimensions=results[result['step']][result['fieldname']]
-			results[result['step']][result['fieldname']]=[patchdimensions[0]+result['M'],result['N']]
+			patchdimensions=getattr(results[result['step']-1],result['fieldname'])
+			setattr(results[result['step']-1],result['fieldname'],[patchdimensions[0]+result['M'],result['N']])
 
 		#read next result
@@ -116,6 +119,6 @@
 	for result in results.itervalues():
 		if 'Patch' in result:
-			result['Patch']=numpy.zeros(shape=(result['Patch'][0],result['Patch'][1]),dtype=float)
-			result['counter']=0    #use to index into the patch
+			setattr(result,'Patch',numpy.zeros((result['Patch'][0],result['Patch'][1])))
+			setattr(result,'counter',0)    #use to index into the patch
 
 	#third pass, this time to read the real information
@@ -125,19 +128,20 @@
 
 		#Get time and step
-		if result['step'] not in results:
-			results[result['step']]=OrderedDict()
-			results[result['step']]['step']=result['step']
-			results[result['step']]['time']=result['time'] 
+		if result['step']> len(results):
+			for i in xrange(len(results),result['step']-1):
+				results.append(None)
+			results.append(resultsclass.results())
+		setattr(results[result['step']-1],'step',result['step'])
+		setattr(results[result['step']-1],'time',result['time']) 
 
 		#Add result
 		if strcmpi(result['fieldname'],'Patch'):
-			counter=results[result['step']]['counter']
+			counter=results[result['step']-1].counter
 			counter2=counter+result['field'].shape[0]-1
-			results[result['step']][result['fieldname']][counter:counter2,:]=result['field']
-
+			getattr(results[result['step']-1],result['fieldname'])[counter:counter2,:]=result['field']
 			#increment counter: 
-			results[result['step']]['counter']=counter2+1
-		else:
-			results[result['step']][result['fieldname']]=result['field']
+			results[result['step']-1].counter=counter2+1
+		else:
+			setattr(results[result['step']-1],result['fieldname'],result['field'])
 
 		#read next result
@@ -188,5 +192,5 @@
 
 	except struct.error as e:
-		result=OrderedDict()
+		result=None
 
 	return result
@@ -230,5 +234,5 @@
 
 	except struct.error as e:
-		result=OrderedDict()
+		result=None
 
 	return result
Index: issm/trunk/src/m/solve/waitonlock.m
===================================================================
--- issm/trunk/src/m/solve/waitonlock.m	(revision 13405)
+++ issm/trunk/src/m/solve/waitonlock.m	(revision 13975)
@@ -12,5 +12,7 @@
 cluster=md.cluster.name;
 login=md.cluster.login;
-port=md.cluster.port;
+if isprop(md.cluster,'port') 
+	port=md.cluster.port;
+end
 timelimit=md.settings.waitonlock;
 filename=[executionpath '/' md.private.runtimename '/' md.miscellaneous.name '.lock'];
Index: issm/trunk/src/wrappers/AverageFilter/AverageFilter.cpp
===================================================================
--- issm/trunk/src/wrappers/AverageFilter/AverageFilter.cpp	(revision 13975)
+++ issm/trunk/src/wrappers/AverageFilter/AverageFilter.cpp	(revision 13975)
@@ -0,0 +1,56 @@
+/*!\file:  AverageFilter.cpp
+ * \brief fill holes in matlab velocity array
+	this matlab module is an adaptation of a routine written by Robber 
+	Crippen.  The original routine was designed for the SRTM mission at JPL, 
+	and can be found in the current directory, under the name 
+	AverageFilterCrippen.  It fills void holes in an image, using an interpolation 
+	algorithm, and optionnally a smoothing algorithm. 
+	This matlab module extends the Crippen routine to be used in Matlab, 
+	using double arrays found in the workspace, and loaded directly into memory.
+*/
+
+#include "./AverageFilter.h"
+
+void AverageFilterUsage(void){/*{{{*/
+	_printLine_("   AverageFilter usage:");
+	_printLine_("   [image_out]=AverageFilter(image_in,pixels);\n");
+	_printLine_("   where:");
+	_printLine_("      image_in in double format");
+	_printLine_("      pixels: characteristic size of smoothing");
+	_printLine_("      image_out in double format");
+	_printLine_("");
+}/*}}}*/
+WRAPPER(AverageFilter){
+
+	int i,j;
+
+	/* required input: */
+	double* imagein=NULL;
+	int     imagein_rows,imagein_cols;
+	int     smooth;
+
+
+	/* output: */
+	mxArray* pfield=NULL;
+	double* imageout=NULL;
+	int     imageout_rows,imageout_cols;
+
+	/*Boot module: */
+	MODULEBOOT();
+
+	/*checks on arguments on the matlab side: */
+	CheckNumMatlabArguments(nlhs,NLHS,nrhs,NRHS,__FUNCT__,&AverageFilterUsage);
+
+	/*Fetch data: */
+	FetchData(&imagein,&imagein_rows,&imagein_cols,IMAGEIN);
+	FetchData(&smooth,SMOOTH);
+	
+	/*Run core hole filler routine: */
+	AverageFilterx( &imageout,imagein,imagein_rows,imagein_cols,smooth);
+
+	/* output: */
+	WriteData(IMAGEOUT,imageout,imagein_rows,imagein_cols);
+
+	/*end module: */
+	MODULEEND();
+}
Index: issm/trunk/src/wrappers/AverageFilter/AverageFilter.h
===================================================================
--- issm/trunk/src/wrappers/AverageFilter/AverageFilter.h	(revision 13975)
+++ issm/trunk/src/wrappers/AverageFilter/AverageFilter.h	(revision 13975)
@@ -0,0 +1,50 @@
+/*
+	AverageFilter.h
+*/
+
+#ifndef _AVERAGEFILTER_H
+#define _AVERAGEFILTER_H
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
+
+#include "../../c/include/globals.h"
+#include "../../c/modules/modules.h"
+#include "../../c/Container/Container.h"
+#include "../../c/shared/shared.h"
+#include "../bindings.h"
+
+#undef __FUNCT__ 
+#define __FUNCT__  "AverageFilter"
+
+#ifdef _HAVE_MATLAB_MODULES_
+/* serial input macros: */
+#define IMAGEIN prhs[0]
+#define SMOOTH  prhs[1]
+/* serial output macros: */
+#define IMAGEOUT (mxArray**)&plhs[0]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define IMAGEIN PyTuple_GetItem(args,0)
+#define SMOOTH  PyTuple_GetItem(args,1)
+/* serial output macros: */
+#define IMAGEOUT output,0
+#endif
+
+/* serial arg counts: */
+#undef NLHS
+#define NLHS  1
+#undef NRHS
+#define NRHS  2
+
+#endif  /* _AVERAGEFILTER_H */
Index: issm/trunk/src/wrappers/BamgConvertMesh/BamgConvertMesh.cpp
===================================================================
--- issm/trunk/src/wrappers/BamgConvertMesh/BamgConvertMesh.cpp	(revision 13975)
+++ issm/trunk/src/wrappers/BamgConvertMesh/BamgConvertMesh.cpp	(revision 13975)
@@ -0,0 +1,61 @@
+/*\file BamgConvertMesh.c
+ *\brief: bamg module.
+ */
+#include "./BamgConvertMesh.h"
+
+void BamgConvertMeshUsage(void){/*{{{*/
+	_pprintString_("BAMGCONVERTMESH - convert [x y index] to a bamg geom and mesh geom");
+	_pprintLine_("");
+	_pprintLine_("   Usage:");
+	_pprintLine_("      [bamggeom bamgmesh]=BamgConvertMesh(index,x,y);");
+	_pprintLine_("      index: index of the mesh");
+	_pprintLine_("      x,y: coordinates of the nodes");
+	_pprintLine_("");
+}/*}}}*/
+WRAPPER(BamgConvertMesh){
+
+	/*input: */
+	int    *index      = NULL;
+	double *x          = NULL;
+	double *y          = NULL;
+	int     nods,nels,test1,test2;
+
+	/*Output*/
+	BamgMesh *bamgmesh = NULL;
+	BamgGeom *bamggeom = NULL;
+
+	/*Boot module: */
+	MODULEBOOT();
+
+	/*checks on arguments on the matlab side: */
+	CHECKARGUMENTS(NLHS,NRHS,&BamgConvertMeshUsage);
+
+	/*Initialize Bamg outputs*/
+	bamggeom=new BamgGeom();
+	bamgmesh=new BamgMesh();
+
+	/*Input datasets: */
+	FetchData(&index,&nels,&test1,INDEXHANDLE);
+	FetchData(&x,&nods,XHANDLE);
+	FetchData(&y,&test2,YHANDLE);
+
+	/*Check inputs*/
+	if(nels<0) _error_("Number of elements must be positive, check index number of lines");
+	if(nods<0) _error_("Number of nods must be positive, check x and y sizes");
+	if(test1!=3) _error_("index should have 3 columns");
+	if(test2!=nods) _error_("x and y do not have the same length");
+
+	/* Run core computations: */
+	BamgConvertMeshx(bamgmesh,bamggeom,index,x,y,nods,nels);
+
+	/*Generate output Matlab Structures*/
+	WriteData(BAMGGEOMOUT,bamggeom);
+	WriteData(BAMGMESHOUT,bamgmesh);
+
+	/*Clean up*/
+	delete bamggeom;
+	delete bamgmesh;
+
+	/*end module: */
+	MODULEEND();
+}
Index: issm/trunk/src/wrappers/BamgConvertMesh/BamgConvertMesh.h
===================================================================
--- issm/trunk/src/wrappers/BamgConvertMesh/BamgConvertMesh.h	(revision 13975)
+++ issm/trunk/src/wrappers/BamgConvertMesh/BamgConvertMesh.h	(revision 13975)
@@ -0,0 +1,55 @@
+/*!\file BamgConvertMesh.h
+ * \brief: prototype for Data Interpolation mex module.
+ */
+
+#ifndef _BAMGCONVERTMESH_H
+#define _BAMGCONVERTMESH_H
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
+
+#include "../../c/include/globals.h"
+#include "../../c/modules/modules.h"
+#include "../../c/Container/Container.h"
+#include "../../c/shared/shared.h"
+#include "../bindings.h"
+#include "../../c/io/io.h"
+
+#undef __FUNCT__ 
+#define __FUNCT__  "BamgConvertMesh"
+
+#ifdef _HAVE_MATLAB_MODULES_
+/* serial input macros: */
+#define INDEXHANDLE prhs[0]
+#define XHANDLE     prhs[1]
+#define YHANDLE     prhs[2]
+/* serial output macros: */
+#define BAMGMESHOUT    (mxArray**)&plhs[0]
+#define BAMGGEOMOUT    (mxArray**)&plhs[1]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define INDEXHANDLE PyTuple_GetItem(args,0)
+#define XHANDLE     PyTuple_GetItem(args,1)
+#define YHANDLE     PyTuple_GetItem(args,2)
+/* serial output macros: */
+#define BAMGMESHOUT    output,0
+#define BAMGGEOMOUT    output,1
+#endif
+
+/* serial arg counts: */
+#undef NLHS
+#define NLHS  2
+#undef NRHS
+#define NRHS  3
+
+#endif
Index: issm/trunk/src/wrappers/BamgMesher/BamgMesher.cpp
===================================================================
--- issm/trunk/src/wrappers/BamgMesher/BamgMesher.cpp	(revision 13975)
+++ issm/trunk/src/wrappers/BamgMesher/BamgMesher.cpp	(revision 13975)
@@ -0,0 +1,51 @@
+/*\file BamgMesher.c
+ *\brief: mesher that uses the bamg library
+ */
+#include "./BamgMesher.h"
+
+void BamgMesherUsage(void){/*{{{*/
+	_pprintLine_("");
+	_pprintLine_("   usage: [bamgmesh,bamggeom]=" << __FUNCT__ << "(bamgmesh,bamggeom,bamgoptions);");
+	_pprintLine_("");
+}/*}}}*/
+WRAPPER(BamgMesher){
+
+	/*Intermediary*/
+	BamgOpts *bamgopts=NULL;
+	BamgMesh *bamgmesh_in=NULL;
+	BamgGeom *bamggeom_in=NULL;
+	BamgMesh *bamgmesh_out=NULL;
+	BamgGeom *bamggeom_out=NULL;
+
+	/*Boot module*/
+	MODULEBOOT();
+
+	/*checks on arguments on the matlab side: */
+	CHECKARGUMENTS(NLHS,NRHS,&BamgMesherUsage);
+
+	/*Initialize outputs*/
+	bamggeom_out=new BamgGeom();
+	bamgmesh_out=new BamgMesh();
+
+	/*Fetch inputs: */
+	FetchData(&bamgopts,BAMGOPTIONS);
+	FetchData(&bamggeom_in,BAMGGEOMIN);
+	FetchData(&bamgmesh_in,BAMGMESHIN);
+
+	/*Call x layer*/
+	Bamgx(bamgmesh_out,bamggeom_out,bamgmesh_in,bamggeom_in,bamgopts);
+
+	/*Generate output Matlab Structures*/
+	WriteData(BAMGGEOMOUT,bamggeom_out);
+	WriteData(BAMGMESHOUT,bamgmesh_out);
+
+	/*Free ressources: */
+	delete bamgopts;
+	delete bamggeom_in;
+	delete bamggeom_out;
+	delete bamgmesh_in;
+	delete bamgmesh_out;
+
+	/*end module: */
+	MODULEEND();
+}
Index: issm/trunk/src/wrappers/BamgMesher/BamgMesher.h
===================================================================
--- issm/trunk/src/wrappers/BamgMesher/BamgMesher.h	(revision 13975)
+++ issm/trunk/src/wrappers/BamgMesher/BamgMesher.h	(revision 13975)
@@ -0,0 +1,54 @@
+/*
+	BamgMesher.h
+*/
+
+#ifndef _BAMG_MESHER_H_
+#define _BAMG_MESHER_H_
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
+
+#include "../../c/include/globals.h"
+#include "../../c/modules/modules.h"
+#include "../../c/Container/Container.h"
+#include "../../c/shared/shared.h"
+#include "../bindings.h"
+
+#undef __FUNCT__ 
+#define __FUNCT__  "BamgMesher"
+
+#ifdef _HAVE_MATLAB_MODULES_
+/* serial input macros: */
+#define BAMGMESHIN  prhs[0]
+#define BAMGGEOMIN  prhs[1]
+#define BAMGOPTIONS prhs[2]
+/* serial output macros: */
+#define BAMGMESHOUT (mxArray**)&plhs[0]
+#define BAMGGEOMOUT (mxArray**)&plhs[1]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define BAMGMESHIN  PyTuple_GetItem(args,0)
+#define BAMGGEOMIN  PyTuple_GetItem(args,1)
+#define BAMGOPTIONS PyTuple_GetItem(args,2)
+/* serial output macros: */
+#define BAMGMESHOUT output,0
+#define BAMGGEOMOUT output,1
+#endif
+
+/* serial arg counts: */
+#undef NLHS
+#define NLHS  2
+#undef NRHS
+#define NRHS  3
+
+#endif  /* _BAMG_MESHER_H_ */
Index: issm/trunk/src/wrappers/BamgTriangulate/BamgTriangulate.cpp
===================================================================
--- issm/trunk/src/wrappers/BamgTriangulate/BamgTriangulate.cpp	(revision 13975)
+++ issm/trunk/src/wrappers/BamgTriangulate/BamgTriangulate.cpp	(revision 13975)
@@ -0,0 +1,56 @@
+/*\file BamgTriangulate.c
+ *\brief: bamg module.
+ */
+#include "./BamgTriangulate.h"
+
+void BamgTriangulateUsage(void){/*{{{*/
+	_pprintString_("BAMGTRIANGULATE - Delaunay Triangulation of a list of points");
+	_pprintLine_("");
+	_pprintLine_("   Usage:");
+	_pprintLine_("      index=BamgTriangulate(x,y);");
+	_pprintLine_("      index: index of the triangulation");
+	_pprintLine_("      x,y: coordinates of the nodes");
+	_pprintLine_("");
+}/*}}}*/
+WRAPPER(BamgTriangulate){
+
+	/*input: */
+	double* x=NULL;
+	double* y=NULL;
+	int     x_cols;
+	int     y_rows,y_cols;
+	int nods;
+
+	/*Output*/
+	int* index=NULL;
+	int  nels;
+
+	/*Intermediary*/
+	int verbose=0;
+
+	/*Boot module: */
+	MODULEBOOT();
+
+	/*checks on arguments on the matlab side: */
+	CheckNumMatlabArguments(nlhs,NLHS,nrhs,NRHS,__FUNCT__,&BamgTriangulateUsage);
+
+	/*Input datasets: */
+	if (verbose) _printLine_("Fetching inputs");
+	FetchData(&x,&nods,&x_cols,XHANDLE);
+	FetchData(&y,&y_rows,&y_cols,YHANDLE);
+
+	/*Check inputs*/
+	if(y_rows!=nods)         _error_("x and y do not have the same length");
+	if(x_cols>1 || y_cols>1) _error_("x and y should have only one column");
+	if(nods<3)               _error_("At least 3 points are required");
+
+	/* Run core computations: */
+	if (verbose) _printLine_("Call core");
+	BamgTriangulatex(&index,&nels,x,y,nods);
+
+	/*Write output*/
+	WriteData(INDEX,index,nels,3);
+
+	/*end module: */
+	MODULEEND();
+}
